/*
RunWithSIze (C) 2017 Tatsuhiko Syoji
The sources for RunWithSIze are distributed under the MIT open source license
*/
#include "RunWithSize.h"

DWORD taqrgetPid;
bool resized;
bool noWin10;
bool topMost;

int APIENTRY _tWinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPTSTR    lpCmdLine,
	int       nCmdShow)
{
	TCHAR *commandWord;
	TCHAR *commandLine;
	TCHAR *nextStart;
	struct positionInfo info;

	noWin10 = false;
	topMost = false;

	// ̎擾
	commandWord = getWord(lpCmdLine, &nextStart);
	if (commandWord == NULL) {
		// PꂪȂƂɂs̏ꍇ͉Ȃ
		showErrorMessage();
		return 1;
	}
	if (nextStart == NULL) {
		// P؂o_ŕIɓBꍇ(s̏ꍇ)͉Ȃ
		showErrorMessage();
		return 1;
	}
	if (!_tcscmp(_T("?"), commandWord)) {
		info.noWidth = true;
	} else {
		info.width = _tstoi(commandWord);
		info.noWidth = false;
	}

	// ̎擾
	commandWord = getWord(nextStart, &nextStart);
	if (commandWord == NULL) {
		// PꂪȂƂɂs̏ꍇ͉Ȃ
		showErrorMessage();
		return 1;
	}
	if (nextStart == NULL) {
		// P؂o_ŕIɓBꍇ(s̏ꍇ)͉Ȃ
		showErrorMessage();
		return 1;
	}
	if (!_tcscmp(_T("?"), commandWord)) {
		info.noHeight = true;
	} else {
		info.height = _tstoi(commandWord);
		info.noHeight = false;
	}

	// ʒu̎擾
	commandWord = getWord(nextStart, &nextStart);
	if (commandWord == NULL) {
		// PꂪȂƂɂs̏ꍇ͉Ȃ
		showErrorMessage();
		return 1;
	}
	if (nextStart == NULL) {
		// P؂o_ŕIɓBꍇ(s̏ꍇ)͉Ȃ
		showErrorMessage();
		return 1;
	}
	if (!_tcscmp(_T("?"), commandWord)) {
		info.noXpos = true;
		info.fromRight = false;
	} else {
		if (_totupper(*commandWord) == _T('R')) {
			info.x = _tstoi(commandWord + 1);
			info.fromRight = true;
		} else {
			info.x = _tstoi(commandWord);
			info.fromRight = false;
		}
		info.noXpos = false;
	}

	// cʒu̎擾
	commandWord = getWord(nextStart, &nextStart);
	if (commandWord == NULL) {
		// PꂪȂƂɂs̏ꍇ͉Ȃ
		showErrorMessage();
		return 1;
	}
	if (nextStart == NULL) {
		// P؂o_ŕIɓBꍇ(s̏ꍇ)͉Ȃ
		showErrorMessage();
		return 1;
	}
	if (!_tcscmp(_T("?"), commandWord)) {
		info.noYpos = true;
		info.fromBottom = false;
	} else {
		if (_totupper(*commandWord) == _T('B')) {
			info.y = _tstoi(commandWord + 1);
			info.fromBottom = true;
		} else {
			info.y = _tstoi(commandWord);
			info.fromBottom = false;
		}
		info.noYpos = false;
	}

	// R}hC̎擾
	// ܂Ǎ̂Ƃ܂ōsB
	commandLine = getWordStart(nextStart);

	if (commandLine != NULL) {
		commandLine = getOptions(commandLine);
	}

	if (commandLine == NULL) {
		// R}hCȂꍇ͉Ȃ
		showErrorMessage();
		return 1;
	}

	return runWithSize(
		&info,
		commandLine);
}

/**
 * IvV擾B
 *
 * @param start 擾Jnʒu
 * @return IvVR}hCJnʒu
 */
TCHAR *getOptions(TCHAR *start)
{
	TCHAR *p;
	bool found = true;

	p = start;

	while (found) {
		if (strcmpspc(p, _T("/no10")) != NULL) {
			noWin10 = true;
			p = p + 5;
			p = getWordStart(p);
			if (p == NULL) {
				return NULL;
			}
			found = true;
			continue;
		}

		if (strcmpspc(p, _T("/top")) != NULL) {
			topMost = true;
			p = p + 4;
			p = getWordStart(p);
			if (p == NULL) {
				return NULL;
			}
			found = true;
			continue;
		}
		found = false;
	}

	return p;
}

//typedef int (WINAPI *pMessageBox)(HWND hWnd, LPCTSTR lpText, LPCTSTR lpCaption, UINT uType);

/**
 * G[bZ[W\
 */
void showErrorMessage(void)
{
	//HMODULE user32Dll = LoadLibrary(_T("user32.dll"));
	//pMessageBox PMessageBox = 
	//	(pMessageBox)GetProcAddress(user32Dll, "MessageBoxW");
	MessageBox(
		NULL,
		_T("RunWithSize Version 1.0.4 By Tatsuhiko Syoji 2017\nUsage:\nRunWithSize width height x y (Options...) CommandLine\n"
			"Options:\n"
			"/top Show window above other windows\n"
			"/no10 Don't adjust window size and position on Windows 10.\n"),
		_T("How to use"),
		MB_OK | MB_ICONINFORMATION);
	//FreeLibrary(user32Dll);
}

/**
 * P؂oB<br>
 * PꂪꍇANULL^[~l[gsB
 *
 * @param targetStr P؂oΏە
 * @param nextPtr ̒P؂oJnʒu
 * @return NULL:PꂪȂ NULL:Pꂪ
 */
TCHAR *getWord(LPTSTR targetStr, TCHAR **nextPtr)
{
	TCHAR *p;

	p = targetStr;
	*nextPtr = NULL;

	// ŏ̃Xy[XȊO̕T
	while (*p) {
		if (!_istspace(*p)) {
			break;
		}
		p++;
	}
	if (*p == _T('\0')) {
		return NULL;
	}
	TCHAR *wordStart = p;

	while (*p) {
		if (_istspace(*p)) {
			*p = _T('\0');
			*nextPtr = p + 1;
			break;
		}
		p++;
	}
	return wordStart;
}

/**
 * Xy[XȊO̎̎n܂B
 *
 * @param targetStr P؂oΏە
 * @return NULL:ȏ݂̎͑Ȃ NULL:傪݂
 */
TCHAR *getWordStart(LPTSTR targetStr)
{
	TCHAR *p;

	p = targetStr;

	// ŏ̃Xy[XȊO̕T
	while (*p) {
		if (!_istspace(*p)) {
			break;
		}
		p++;
	}
	if (*p == _T('\0')) {
		return NULL;
	}
	return p;
}

/**
 * Xy[Xŋ؂ꂽPr
 *
 * @param target Ώە
 * @param toSearch r镶
 * @return NULL:Ώە͔r镶񂾂 NULL:Ώە͔r镶ł͂ȂB
 */
TCHAR *strcmpspc(TCHAR *target, TCHAR *toSearch)
{
	TCHAR *p;
	TCHAR *s;

	p = target;
	s = toSearch;


	p = target;
	while (*p) {

		if (_istspace(*p)) {
			// P̐؂ڂŃXy[X猩ƂƂB
			if (*s == _T('\0')) {
				return target;
			}
		}
		if (*p != *s) {
			return NULL;
		}
		p++;
		s++;
	}
	if (*s == _T('\0')) {
		// ǂIĂ
		return target;
	}
	return NULL;
}

// eEChEɑ΂`FbNsR[obN
BOOL CALLBACK setWindowSize(HWND hWnd, LPARAM lparam)
{
	DWORD wndPid;
	struct positionInfo *posInfo;

	DWORD version = GetVersion();
	DWORD versionHigh = (DWORD)(LOBYTE(LOWORD(version)));

	posInfo = (struct positionInfo *)lparam;

	// NvÕEChET
	GetWindowThreadProcessId(hWnd, &wndPid);
	if (wndPid == taqrgetPid) {
		// ȂEChE̓TCY𒲐Ă傤Ȃ̂ŁA
		// ΏۂƂȂ
		if (IsWindowVisible(hWnd)) {
			RECT place;

			if (IsWindow(hWnd)) {
				NONCLIENTMETRICS metrics;
				FillMemory(&metrics, sizeof(NONCLIENTMETRICS), 0x00);
				metrics.cbSize = sizeof(NONCLIENTMETRICS);
				SystemParametersInfo(SPI_GETNONCLIENTMETRICS,
					metrics.cbSize,
					&metrics,
					0);

				GetWindowRect(hWnd, &place);

				// ̌vZ
				if (!posInfo->noXpos) {
					// w肵_Ă
					place.left = posInfo->x;
					place.right = posInfo->x;
					if ((versionHigh == 10) && (!noWin10)) {
						// Windows 10͌ڂ̃EChE̊Oɓ̘gƋ󔒂̂
						// ʒuڂ̈ʒuɍ킹
						if (posInfo->fromRight) {
							// ËʒuvZ̏ꍇ
							place.right =
								posInfo->x +
								4 +
								(metrics.iPaddedBorderWidth - 1) +
								(metrics.iBorderWidth - 1);
						} else {
							place.left =
								place.left -
								4 -
								(metrics.iPaddedBorderWidth - 1) -
								(metrics.iBorderWidth - 1);
						}
					}
				}
				if (!posInfo->noYpos) {
					place.top = posInfo->y;
					place.bottom = posInfo->y;
					if ((versionHigh == 10) && (!noWin10)) {
						// Windows 10͌ڂ̃EChE̊Oɓ̘gƋ󔒂̂
						// ʒuڂ̈ʒuɍ킹
						// A͌ڂƃVXȅ[B
						if (posInfo->fromBottom) {
							place.bottom = posInfo->y +
								4 +
								(metrics.iBorderWidth - 1) +
								(metrics.iPaddedBorderWidth - 1);
						}
					}

				}

				// ĚvZ
				RECT r;
				GetWindowRect(hWnd, &r);
				int orgWidth = r.right - r.left;
				int orgHeight = r.bottom - r.top;

				// ̌vZ
				int width;
				if (posInfo->noWidth) {
					width = orgWidth + 1;
				} else {
					width = posInfo->width;
					if ((versionHigh == 10) && (!noWin10)) {
						// Windows 10͌ڂ̊̕Oɓ̘gƋ󔒂̂ŁA
						// ڂ̕w肵ɍ킹
						width =
							width +
							8 +
							((metrics.iBorderWidth - 1) + (metrics.iPaddedBorderWidth - 1)) * 2;
					}
				}

				int height;
				if (posInfo->noHeight) {
					height = orgHeight + 1;
				} else {
					height = posInfo->height;
					if ((versionHigh == 10) && (!noWin10)) {
						height =
							height +
							(metrics.iBorderWidth - 1) +
							(metrics.iPaddedBorderWidth - 1) +
							4;

					}
				}

				// ƂƂ̃EChȆ傫0*0̂̂̓TCYΏۂƂȂB
				// DelphiAṽEChENXTApplicatioñEChEɓB
				// \EChE𑊎ɂAÑEChE̗񋓂Ȃ
				// I[i[EChE̗LŔł邪A͕\EChEȂ̂
				// ̂悤ȎiƂKvB
				if ((orgWidth != 0) || (orgHeight != 0)) {
					if (posInfo->fromRight) {
						// E̎w̏ꍇ͍̎w𒼂B
						place.left = place.right - width + 1;
					} else {
						place.right = place.left + width - 1;
					}
					if (posInfo->fromBottom) {
						place.top = place.bottom - height + 1;
					} else {
						place.bottom = place.top + height - 1;
					}

					if (IsWindow(hWnd)) {
						HWND insertAfter = NULL;
						UINT flags = SWP_NOZORDER;
						if (topMost) {
							insertAfter = HWND_TOPMOST;
							flags = SWP_SHOWWINDOW;
						}
						SetWindowPos(
							hWnd,
							insertAfter,
							place.left,
							place.top,
							width,
							height,
							flags);
					}
				}
			}

			resized = true;
			return TRUE;
		}
	}
	return TRUE;
}

/**
 * AA(ʒu)A(cʒu)w肵ăAvP[VN
 *
 * @param  posInfo ʒu
 * @param commandLine
 *
 */
int runWithSize(
	struct positionInfo *posInfo,
	TCHAR *commandLine
)
{
	STARTUPINFO info;
	PROCESS_INFORMATION procInfo;
	BOOL startResult;

	memset(&info, 0, sizeof(STARTUPINFO));
	memset(&procInfo, 0, sizeof(PROCESS_INFORMATION));

	if (!posInfo->noXpos) {
		info.dwX = posInfo->x;
		info.dwFlags = STARTF_USEPOSITION;
	}
	if (!posInfo->noYpos) {
		info.dwY = posInfo->y;
		info.dwFlags = STARTF_USEPOSITION;
	}
	info.dwXSize = posInfo->width;
	info.dwYSize = posInfo->height;
	info.dwFlags |= STARTF_USESIZE;

	startResult = CreateProcess(
		NULL,
		commandLine,
		NULL,
		NULL,
		FALSE,
		0,
		NULL,
		NULL,
		&info,
		&procInfo
	);

	if (startResult == FALSE) {
		return 1;
	}

	taqrgetPid = procInfo.dwProcessId;

	// NvÕEChE5bԒT
	resized = false;
	for (int i = 0; resized == false && i < 5; i++) {
		// AvTCYAAv̋N҂肷̂
		// ̕҂
		Sleep(1000);
		EnumWindows(setWindowSize, (LPARAM)posInfo);
	}


	CloseHandle(procInfo.hThread);
	CloseHandle(procInfo.hProcess);


	return 0;
}